;; Eulisp Module
;; Author: pab
;; File: table.em
;; Date: Wed Jun 30 12:46:18 1993
;;
;; Project:
;; Description: 
;;

(defmodule table
  (gens init extras0 macros0 defs
	)
  ()
  
  (export tablep table-ref setter-table-ref)

  (defpredicate tablep <table>)

  (defgeneric table-ref (table key)
    method (((x <table>) key)
	    (sys-table-ref x key)))

  (defgeneric setter-table-ref (table key value)
    method (((x <table>) key value)
	    ((setter sys-table-ref) x key value)))
  
  ((setter setter) table-ref setter-table-ref)

  (defmethod initial-state ((tab <table>)) (table-keys tab))

  (defmethod next-state ((tab <table>) (s <null>)) ())

  (defmethod next-state ((tab <table>) (s <cons>)) (cdr s))

  (defmethod final-state ((tab <table>)) (table-keys tab))

  (defmethod previous-state ((tab <table>) (s <null>)) ())

  (defmethod previous-state ((tab <table>) (s <cons>)) (cdr s))

  (defmethod current-element ((tab <table>) (s <cons>))
    (table-ref tab (car s)))

  (defmethod current-key ((tab <table>) (s <cons>)) (car s))

  (defmethod key-sequence ((tab <table>)) (table-keys tab))

  (defmethod element ((tab <table>) k)
    (table-ref tab k))

  (defmethod (setter element) ((tab <table>) k v)
    ((setter table-ref) tab k v))

  (defmethod size ((tab <table>)) (table-population tab))

  (defmethod clone ((tab <table>))
    (make <table> 
	  'hash-function (table-hash-function tab)
	  'comparator (table-comparator tab)
	  'table-fill (table-fill tab)))



  ;; end module
  )
